# Contributing to MementoEmbed

**Note**: that this document will evolve over time as the MementoEmbed project matures. Check the most current version of this document for updates on how to contribute.

Welcome to the MementoEmbed project!

**Did you find a bug?**

* **Ensure that this bug was not already reported** by searching our GitHub issues.

* If you do not find an open issue addressing the problem, open a new one. Be clear about what caused the issue. At a minimum, provide the URI-Ms attempted. If possible, provide the approximate date and time of execution, and any output or screenshots.

**Did you write a patch that fixes the bug?**

Thank you for your proposed contribution.

* Open a new GitHub pull request with the patch.

* Ensure that the PR description clearly describes the problem and solution. Map the PR to an issue number, if applicable.

**Did you write a patch that provides a feature?**

Thank you for your proposed contribution.

* Open a new GitHub pull request with the patch.

* Ensure that the PR description clearly describes the problem and solution. Map the PR to an issue number, if applicable.

We will consider all feature requests (especially those with a PR). We apologize in advance if your contribution is not accepted. We are prioritizing bug fixes over requested features at the current time.

**Did you fix whitespace, format code, or suggest a purely cosmetic patch?**

Cosmetic changes that do not add anything substantial to the execution of MementoEmbed will generally not be accepted. Our currently focus for MementoEmbed is functionality. It takes a lot of work and contributions by the community to ensure that more than 20 years of archived web pages can be represented cleanly.

**Do you want to build the source?**

We try to take full advantage of the capabilities of `pip`. To install locally, clone the source repository, change into the directory containing the source and type:
```
pip install .
```

**Do you want to run the automated tests?**

Automated testing is always under development and optimization, so the conditions may change, but executing the automated tests will always be as easy as changing the root directory of the source code and typing:
```
python ./setup.py test
```

**Do you have questions about the source code or the project in general?**

Contact: sjone@cs.odu.edu

Thanks so much for your contributions!!!

The ODU Web Science and Digital Libraries Research Group

Acknowledgements: This contribution file is heavily inspired by the one published by the Ruby on Rails project.
